class JobInputList extends RessourceList {
  constructor(listElement, options = {}) {
    super(listElement, {...JobInputList.options, ...options});
    this.jobId = listElement.dataset.jobId;
  }

  init(user) {
    this._init(user.jobs[this.jobId].inputs);
  }

  onclick(event) {
    let jobInputElement = event.target.closest('tr[data-id]');
    if (jobInputElement === null) {return;}
    let jobInputId = jobInputElement.dataset.id;
    let actionButtonElement = event.target.closest('.action-button[data-action]');
    if (actionButtonElement === null) {return;}
    let action = actionButtonElement.dataset.action;
    switch (action) {
      case 'download':
        window.location.href = `/jobs/${this.jobId}/inputs/${jobInputId}/download`;
        break;
      default:
        break;
    }
  }

  usersPatchHandler(patch) {return;}

  preprocessRessource(jobInput) {
    return {
      id: jobInput.id,
      creationDate: jobInput.creation_date,
      filename: jobInput.filename
    };
  }
}
JobInputList.options = {
  item: `
    <tr>
      <td><span class="filename"></span></td>
      <td class="right-align">
        <a class="action-button btn-floating tooltipped waves-effect waves-light" data-action="download" data-position="top" data-tooltip="View"><i class="material-icons">file_download</i></a>
      </td>
    </tr>
  `.trim(),
  valueNames: [{data: ['id']}, 'filename']
};
